c This file is written by Thi Nhung Dao
C subroutine IBFunc(FBI,m1,m2,m3,mA)
c we follow convention of these functions in arxiv:0709.1075 @Denner
c with following 0->1, 1->2,2->3, without index will be given index 0.
c the minus sign belongs to p1, the plus sign to p2,p3, p1=p2+p3+k
c#define test
c
c subroutine Linearequation_solver(n,a,d,root)
c
c SUBROUTINE Inverse_Gauss (a,b,n)

	subroutine IBFunc(FBI,m1,m2,m3,mA)
        implicit none
        integer i,j,k,l
        double precision m1,m2,m3,mA,beta1,beta2,beta3,
     &                   m12,m22,m32,kappa,m123,kappa2,
     &                   logma,FBI(0:3,0:3,0:3,0:3)
        double complex li2_hdec,li2b1,li2b2,li2b3
     &                 ,logb1,logb2,logb3
        m12=m1**2;m22=m2**2;m32=m3**2
        kappa2=m12**2+m22**2+m32**2-2*m12*m22-2*m22*m32-2*m12*m32
        kappa=sqrt(kappa2)
        m123=m1*m2*m3
        logma=Log(ma)/2D0;
        if(m123.gt.1D-15)then
        beta1= (m12-m22-m32+kappa)/(2*m2*m3)
        beta2= (m12-m22+m32-kappa)/(2*m1*m3)
        beta3= (m12+m22-m32-kappa)/(2*m1*m2)
        logb1=Log(beta1);logb2=Log(beta2);logb3=Log(beta3)

        li2b1=li2_hdec(dcmplx(1-beta1**2,0D0),-1)
        li2b2=li2_hdec(dcmplx(1-beta2**2,0D0),-1)
        li2b3=li2_hdec(dcmplx(1-beta3**2,0D0),-1)


        FBI(0,0,0,0)=1D0/(4*m12)*(kappa/2D0*(m12+m22+m32)+2*m12*m22*
     &   logb3+2*m12*m32*Logb2+2*m22*m32*logb1)


        FBI(1,0,0,0)=1D0/(4*m12)*(-2*m22*Logb3-2*m32*logb2-kappa)

        FBI(2,0,0,0)=1D0/(4*m12)*(-2*m12*Logb3-2*m32*logb1-kappa)

        FBI(3,0,0,0)=1D0/(4*m12)*(-2*m12*Logb2-2*m22*logb1-kappa)

        FBI(1,1,0,0)=1D0/(4*M12**2)*(kappa*(log(kappa2/m123)-Logma)-kappa
     &       -(m22-m32)*(logb2-logb3)-m12*logb1)

        FBI(2,2,0,0)=1/(4*m22*m12)*(kappa*(log(kappa2/M123)-logma)-kappa
     &       -(m12-m32)*(logb1-logb3)-m22*logb2)

        FBI(3,3,0,0)=1/(4*m32*m12)*(kappa*(log(kappa2/M123)-logma)-kappa
     &       -(m12-m22)*(logb1-logb2)-m32*logb3)

        FBI(1,2,0,0)=1/(4*m12)*(2*(log(kappa2/m123)-logma)*logb3+2*logb3**2
     &       -logb1**2-logb2**2+2*Li2b3-Li2b1-Li2b2)



        FBI(1,3,0,0)=1/(4*m12)*(2*(log(kappa2/m123)-logma)*logb2+2*logb2**2
     &       -logb1**2-logb3**2+2*Li2b2-Li2b1-Li2b3)

        FBI(2,3,0,0)=-FBI(1,2,0,0)-FBI(1,3,0,0)

c        print*, "FBI(2,3,0,0)",FBI(2,3,0,0),Li2b1,Li2b2,Li2b3
c
c        FBI(2,3,0,0)=1/(4D0*m12)*(2*(log(kappa2/m123)-logma)*logb1+2*logb1**2
c     &             - logb2**2-logb3**2 + 2*Li2b1 -Li2b2-Li2b3 )
c
c        print*, "FBI(2,3,0,0)",FBI(2,3,0,0)

        FBI(1,0,2,0)=1D0/(4*m12)*(m22**2*logb3-m32*(2*m12-2*m22+m32)*logb2-
     &        kappa/4D0*(m12-3*m22+5*m32))

        FBI(2,0,1,0)=1D0/(4*m12)*(m12**2*logb3-m32*(2*m22-2*m12+m32)*logb1-
     &        kappa/4D0*(m22-3*m12+5*m32))

        FBI(3,0,1,0)=1D0/(4*m12)*(m12**2*logb2-m22*(2*m32-2*m12+m22)*logb1-
     &        kappa/4D0*(m32-3*m12+5*m22))

        FBI(3,0,2,0)=-FBI(0,0,0,0)-FBI(3,0,1,0)

        FBI(2,0,3,0)=-FBI(0,0,0,0)-FBI(2,0,1,0)


        FBI(1,1,2,3)=-1D0/(4*m12)*(m22**2*logb3+m32**2*logb2+
     &        kappa*kappa2/(6*m12)+kappa/4D0*(3*m22+3*m32-m12))

        FBI(2,2,1,3)=-1/(4*m12)*(m12**2*logb3+m32**2*logb1+kappa*
     &        kappa2/(6*m22)+kappa/4D0*(3*m12+3*m32-m22))
        FBI(3,3,1,2)= -1/(4*m12)*(m12**2*logb2+m22**2*logb1+kappa*
     &        kappa2/(6*m32)+kappa/4D0*(3*m12+3*m22-m32))

        FBI(2,2,1,1)=-FBI(2,0,1,0)-FBI(2,2,1,3)
        FBI(1,1,2,2)=-FBI(1,0,2,0)-FBI(1,1,2,3)
        FBI(2,2,3,3)=-FBI(2,0,3,0)-FBI(2,2,1,3)

        FBI(3,3,2,2)=-FBI(3,0,2,0)-FBI(3,3,1,2)
        FBI(3,3,2,1)=        FBI(3,3,1,2)
c new 23 sept 2019
        FBI(3,2,0,0)=FBI(2,3,0,0)
        FBI(3,1,0,0)=FBI(1,3,0,0)
        FBI(2,1,0,0)=FBI(1,2,0,0)
        FBI(1,0,3,0)=-FBI(0,0,0,0)-FBI(1,0,2,0)

        FBI(3,3,1,1)=-FBI(3,0,1,0)-FBI(3,3,1,2)

        FBI(1,2,3,3)=-FBI(2,0,3,0)-FBI(1,0,3,0)
        FBI(2,1,3,3)=        FBI(1,2,3,3)

        FBI(3,2,1,1)=-FBI(2,0,1,0)-FBI(3,0,1,0)
        FBI(2,3,1,1)=FBI(3,2,1,1)

         else
           if(m22.eq.0)then
           logb2=  log(m3/m1)
           li2b2=li2_hdec(dcmplx(1-(m3/m1)**2,0D0),-1)

        FBI(0,0,0,0)=1D0/(4*m12)*(kappa/2D0*(m12+m32)+2*m12*m32*Logb2)

        FBI(1,0,0,0)=1D0/(4*m12)*(-2*m32*logb2-kappa)
        FBI(3,0,0,0)=1D0/(4*m12)*(-2*m12*Logb2-kappa)

        FBI(1,0,2,0)=1D0/(4*m12)*(-m32*(2*m12-2*m22+m32)*logb2-
     &        kappa/4D0*(m12+5*m32))

        FBI(1,0,3,0)=-FBI(0,0,0,0)-FBI(1,0,2,0)

        FBI(3,0,1,0)=1D0/(4*m12)*(m12**2*logb2-kappa/4D0*(m32-3*m12))


        FBI(3,0,2,0)=-FBI(0,0,0,0)-FBI(3,0,1,0)

        FBI(1,1,0,0)=1D0/(4*M12**2)*(kappa*(log(kappa2)-Logma)-kappa
     &       +m32*(log(2*m32*m1))-m12*log(kappa*m1))


        FBI(3,3,0,0)=1/(4*m32*m12)*(kappa*(log(kappa2)-logma)-kappa
     &       -(m12)*(log(kappa*m1)-logb2)-m32*log(1/(2*m1*m32)))


        FBI(3,1,0,0)=1/(4*m12)*(2*(log(kappa2)-logma)*logb2+2*logb2**2
     &        +2*Li2b2 -logb2*log(m12*m3*kappa*m1) )
        
        FBI(1,3,0,0)=        FBI(3,1,0,0)
           endif
         endif

c nhung for test
#ifdef test
        FBI(1,1,0,0)=1D0/(4*M12**2)*(kappa*(-Logma))

        FBI(2,2,0,0)=1/(4*m22*m12)*(kappa*(-logma))

        FBI(3,3,0,0)=1/(4*m32*m12)*(kappa*(-logma))

        FBI(1,2,0,0)=1/(4*m12)*(2*(-logma)*logb3)

        FBI(1,3,0,0)=1/(4*m12)*(2*(-logma)*logb2)

        FBI(3,1,0,0)=1/(4*m12)*(2*(-logma)*logb2)

        FBI(2,3,0,0)=-FBI(1,2,0,0)-FBI(1,3,0,0)
        FBI(3,2,0,0)=-FBI(1,2,0,0)-FBI(1,3,0,0)

#endif
c end nhung test

        end
***********************************************************************
	SUBROUTINE Inverse_Gauss (a,b,n)       ! Invert matrix by Gauss method
! --------------------------------------------------------------------
	IMPLICIT NONE

	INTEGER :: n
	double complex :: a(n,n),b(n,n)

	! - - - Local Variables - - -
	double complex ::  c, d, temp(n)
	INTEGER :: i, j, k, m, imax(1), ipvt(n)
	! - - - - - - - - - - - - - -

	b = a
	ipvt = (/ (i, i = 1, n) /)

	DO k = 1,n
  	 imax = MAXLOC(ABS(b(k:n,k)))
  	 m = k-1+imax(1)

  	 IF (m /= k) THEN
  	    ipvt( (/m,k/) ) = ipvt( (/k,m/) )
  	    b((/m,k/),:) = b((/k,m/),:)
 	  END IF
	   d = 1/b(k,k)

	   temp = b(:,k)
	   DO j = 1, n
	      c = b(k,j)*d
	      b(:,j) = b(:,j)-temp*c
	      b(k,j) = c
	   END DO
	   b(:,k) = temp*(-d)
	   b(k,k) = d
	END DO

	END SUBROUTINE Inverse_Gauss 

#include "../diag-f.h"
************************************************************************
** CEigensystem diagonalizes a general complex n-by-n matrix.
** Input: n, A = n-by-n matrix
** Output: d = vector of eigenvalues, U = transformation matrix
** these fulfill diag(d) = U A U^-1.

	subroutine CEigensystem(n, A,ldA, d, U,ldU, sort)
	implicit none
	integer n, ldA, ldU, sort
	double complex A(ldA,*), U(ldU,*), d(*)

	integer p, q, j
	double precision red, off, thresh
	double complex delta, t, invc, sx, sy, tx, ty
	double complex x, y
	double complex ev(2,MAXDIM)

	integer sweep
	common /nsweeps/ sweep

	double precision sq
	double complex c
	sq(c) = DBLE(c*DCONJG(c))

	if( n .gt. MAXDIM ) then
	  print *, "Dimension too large"
	  d(1) = -999
	  return
	endif

	do p = 1, n
	  ev(1,p) = 0
	  ev(2,p) = A(p,p)
	  d(p) = ev(2,p)
	enddo

	do p = 1, n
	  do q = 1, n
	    U(q,p) = 0
	  enddo
	  U(p,p) = 1
	enddo

	red = .01D0/n**4

	do sweep = 1, 50
	  off = 0
	  do q = 2, n
	    do p = 1, q - 1
	      off = off + sq(A(p,q)) + sq(A(q,p))
	    enddo
	  enddo
	  if( off .lt. EPS ) goto 1

	  thresh = 0
	  if( sweep .lt. 4 ) thresh = off*red

	  do q = 2, n
	    do p = 1, q - 1
	      off = sq(A(p,q)) + sq(A(q,p))
	      if( sweep .gt. 4 .and. off .lt.
     &              EPS*max(sq(ev(2,p)), sq(ev(2,q))) ) then
	        A(p,q) = 0
	        A(q,p) = 0
	      else
	        if( off .gt. thresh ) then
	          delta = A(p,q)*A(q,p)
	          x = .5D0*(ev(2,p) - ev(2,q))
	          y = sqrt(x**2 + delta)
	          t = x - y
	          x = x + y
	          if( abs(t) .lt. abs(x) ) t = x

	          t = 1/t
	          delta = delta*t
	          ev(1,p) = ev(1,p) + delta
	          ev(2,p) = d(p) + ev(1,p)
	          ev(1,q) = ev(1,q) - delta
	          ev(2,q) = d(q) + ev(1,q)

	          invc = sqrt(delta*t + 1)
	          x = t/invc
	          t = t/(invc + 1)
	          sx = x*A(p,q)
	          ty = t*A(p,q)
	          sy = x*A(q,p)
	          tx = t*A(q,p)

	          do j = 1, n
	            x = A(j,p)
	            y = A(j,q)
	            A(j,p) = x + sy*(y - ty*x)
	            A(j,q) = y - sx*(x + tx*y)
	            x = A(p,j)
	            y = A(q,j)
	            A(p,j) = x + sx*(y - tx*x)
	            A(q,j) = y - sy*(x + ty*y)
	          enddo

	          A(p,q) = 0
	          A(q,p) = 0

	          do j = 1, n
	            x = U(p,j)
	            y = U(q,j)
	            U(p,j) = x + sx*(y - tx*x)
	            U(q,j) = y - sy*(x + ty*y)
	          enddo
	        endif
	      endif
	    enddo
	  enddo

	  do p = 1, n
	    ev(1,p) = 0
	    d(p) = ev(2,p)
	  enddo
	enddo

	print *, "Bad convergence in CEigensystem"

1	if( sort .eq. 0 ) return

* sort the eigenvalues by their real part

	do p = 1, n - 1
	  j = p
	  t = d(p)
	  do q = p + 1, n
	    if( sort*(DBLE(t) - DBLE(d(q))) .gt. 0 ) then
	      j = q
	      t = d(q)
	    endif
	  enddo

	  if( j .ne. p ) then
	    d(j) = d(p)
	    d(p) = t
	    do q = 1, n
	      x = U(p,q)
	      U(p,q) = U(j,q)
	      U(j,q) = x
	    enddo
	  endif
	enddo
	end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c    a(1,1) x(1) +a(2,1) x(2)+ ....+a(n,1) x(n) =d(1)
c    ....
c    a(1,n) x(1) +a(2,n) x(2)+ ....+a(n,n) x(n) =d(n)
c    root(i)= x(i)
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        subroutine Linearequation_solver(n,a,d,root)
        implicit none
        integer i,j, k,id1,n
        double precision a(n,n),d(n),delta,q(4),root(n),eps, x(n)
        parameter (eps=1D-10)
 
         i=n
         do k=1,n-1
           do j=i-1,k,-1
             if (abs(a(k,i)).gt.abs(a(k,j)))then
              x(k:n)=a(k:n,i)
              a(k:n,i)=a(k:n,j)
              a(k:n,j)=x(k:n)
              delta=d(i)
              d(i)=d(j)
              d(j)=delta
             endif
           enddo

           do j=i,k+1,-1  
             if (abs(a(k,j)).gt.eps)then             
               do id1=k+1,n
               a(id1,j) = a(id1,j)* a(k,j-1)- a(id1,j-1)*a(k,j)
               enddo
               d(j)= d(j)*a(k,j-1)-d(j-1)*a(k,j)
               a(k,j)=0
             endif
           enddo
         enddo

       if (abs(a(n,n)).gt.eps)then
       root(n)=d(n)/a(n,n)
       else
       root(n)=0D0
       endif

       do i=n-1,1,-1
         delta= 0
         do j=n,i+1,-1
           delta=delta + root(j)* a(j,i)
         enddo
c        print*,  'delta',delta,abs(a(i,i)),i 
         if (abs(a(i,i)).gt.eps)then 
         root(i) =  (d(i)-delta)/a(i,i)
         else
         root(i)=0D0
         endif
       enddo
        
c       print*, ' a(1)', a(1:3,1),d(1),root(1)
c       print*, ' a(2)', a(1:3,2),d(2),root(2)
c       print*, ' a(3)', a(1:3,3),d(3),root(3)
       
        end subroutine Linearequation_solver


